#pragma once
#include "pandaAlgorithm.h"
#include "genome.h"

#include <memory>
#include <string>
#include <vector>
#include <map>
#include <time.h>
#include<stdlib.h>

using namespace std;

#define MAX_RANDOM 2147483647.0

class  OptScheduling;
/**
   Ŵ㷨
*/
class PANDAALGORITHM_API  GenAlg
{
public:
    //캯  
   explicit GenAlg(std::shared_ptr<OptScheduling>optScheduling);

    //ʼ  
    void reset();

    //ʼ  
    void init(int popsize, double MutRate, double CrossRate, int GenLenght, double LeftPoint, double RightPoint);

    // mTotalFitness, mBestFitness, mWorstFitness, mAverageFitnessȱ  
    void calculateBestWorstAvTot();

    // ̶ѡ  
    Genome chromoRoulette();

    // 캯ʵֵ룩  
    void mutate(vector<double>& chromo);

    //⺯һ  
    void epoch(vector<Genome>& vecNewPop);

    // ȡӦȵĻ
    Genome bestFitness();

    // ȡƽӦ
    double averageFitness();

    /**
    * @brief 룬ͽɻ㷨
    * @param [genVals] ݼ
    */
    void decoding(vector<map<string, float>> & genVals);
  
    // ѡ㣬ǰȺӦȽϸߵĸ尴ĳֹģŴһȺ
    void select(vector<Genome>& genVec);

    /**
     * @brief 
     * @param [parent] 
     * @param [son] Ӵ
     */
    void crossover(const vector<Genome>& parent, vector<Genome>& son );

    /**
    * @brief ݼֵӦ
    * @param [cost] ܺ
    * @param [monitorValues] ֵ
    * @return Ӧֵ
    */
    double fitnessfunction(float cost, map<string,double>& monitorValues);

    /**
     * @brief ȺӦ
     * @param [index] Ⱥĸ
     * @param [fitNess] Ӧ
     */
    void updateGenomeFitNess(int index, double fitNess);

    void setPumpVec(const vector<string>& pumpVec) { mPumpVec = pumpVec; }
private:
    // [a,b)֮ĸ
    double random(int a=0, int b= RAND_MAX);

    // 飬µĸ
    Genome crossover(const Genome& gen1, const Genome& gen2);

private:
    // ǰȺ 
    vector <Genome>   vecPop;

    // һȺ
    vector<Genome> nextPopulation;

    // мȺ
    vector<Genome> midPopulation;

    // Ⱥ  
    int mPopSize;

    // ÿһȾɫĻĿ  
    int mChromoLength;

    // иӦӦֵܺ  
    double mTotalFitness;

    // и嵱ӦĸӦ  
    double mBestFitness;

    // ¼иֵ
    Genome mBestGenoMe;

    Genome mWorthGenoMe;

    // иӦֵƽֵ  
    double mAverageFitness;

    // и嵱ӦĸӦ  
    double mWorstFitness;

    // Ӧĸm_vecPop  
    Genome mFittestGenome;

    // ͻĸ,һ0.050.3֮  
    double mMutationRate = 0.2;

    // 򽻲ĸһΪ0.7  
    double mCrossoverRate = 0.7;

    // ļ  
    int mGeneration;

    // 첽  
    double mMaxPerturbation;

    // ߽
    double mLeftPoint;

    // ұ߽
    double mRightPoint;

    // 
    vector<string> mPumpVec;

    // ŻȺ
    std::shared_ptr<OptScheduling> mOptScheduling = nullptr;
};
