#pragma once

#include "CivMetaType.h"

/**
    ԭ
*/
class  CivVariant
{
public:
    typedef CivMetaType::Type Type;

    ~CivVariant();
    CivVariant(Type type = Type::Null);
    CivVariant(const CivVariant& other);

    CivVariant(int i);

    CivVariant(bool b);
    CivVariant(double d);
    CivVariant(float f);

    Type type() const;
    int userType() const;
    const char* typeName() const;

    bool canConvert(int targetTypeId) const;
    bool convert(int targetTypeId);

    inline bool isValid() const;
    bool isNull() const;

    void clear();

    void detach();
    inline bool isDetached() const;

    int toInt(bool* ok = nullptr) const;
    bool toBool() const;
    double toDouble(bool* ok = nullptr) const;
    float toFloat(bool* ok = nullptr) const;

    static const char* typeToName(int typeId);
    static Type nameToType(const char* name);

    void* data();
    const void* constData() const;
    inline const void* data() const { return constData(); }

private:

};
